'use strict';

var doc = document;

function h(tagName, props) {
  if (typeof tagName !== 'string') {
    throw Error('tagName must be a string');
  }

  var el = doc.createElement(tagName);

  if (!props) {
    // pass
  } else if (typeof props === 'string') {
    el.className = props;
  } else if (typeof props === 'object') {
    for (var key in props) {
      if (key === 'style') {
        el.style.cssText = props[key];
      } else {
        el[key] = props[key];
      }
    }
  } else {
    throw Error('props must be an object, a string, or falsy');
  }

  var parent = el.content || el;

  for (var i = 2, len = arguments.length; i < len; i++) {
    append(parent, arguments[i]);
  }

  return el;
}

function append(parent, child) {
  if (child instanceof Node) {
    parent.appendChild(child);
  } else if (typeof child === 'string') {
    parent.appendChild(doc.createTextNode(child));
  } else if (!child) {
    // pass
  } else if (Array.isArray(child)) {
    for (var i = 0, len = child.length; i < len; i++) {
      append(parent, child[i]);
    }
  } else {
    throw Error('children must be Nodes, strings, Arrays, or falsy');
  }
}

module.exports = h;